//
//  GFTPControl.java
//  GFPut
//
//  Created by grgr56 on Mon Nov 26 2001.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import com.cqs.ftp.*;
import java.util.*;

public class GFTPControl implements Runnable{
    GFCtrl boss;
    ConnectionInfo info;
    Vector filenames;
    int transferMode;
    
    public GFTPControl(){
    
    }
    public void setBoss(GFCtrl _boss){
        boss = _boss;
    }
    public void setInfo(ConnectionInfo _info, Vector _filenames,int _transferMode){
        info = _info;
        filenames = _filenames;
        transferMode = _transferMode;
    }
    
    public void run() {
	ftp();
        boss.ftpFinished();
    	return;
    }
    
    public  void ftp()
    {
        boss.setFtpStatus("Connecting to host..");
        
        FTP ftp = new FTP(info.getHostAddress(), 21);
        ftp.setLogFile("ftp.log");

        ftp.connect();
        System.out.print(ftp.lastReply());
        if (ftp.lastCode() != FTP.CODE_CONNECT_OK)
        {
            boss.setFtpStatus("Connection failed.");
            return;
        }

        boss.setFtpStatus("Logging in..");
        ftp.login(info.getUserName(), info.getPassword());
        System.out.print(ftp.lastReply());
        if (ftp.lastCode() != FTP.CODE_LOGGEDIN)
        {
            boss.setFtpStatus("incorrect login.");
            ftp.disconnect();
            return;
        }

        ftp.setTransfer(FTP.TRANSFER_PASV);
        switch(transferMode){
            case 0:
           	ftp.setMode(FTP.MODE_AUTO);
                break;
            case 1:
                ftp.setMode(FTP.MODE_ASCII);
                break;
            case 2:
                ftp.setMode(FTP.MODE_BINARY);
                break;
            default:
                break;
        }
        
        boss.setFtpStatus("Changing Directory..");
        for(Enumeration e=filenames.elements();e.hasMoreElements();){
            String filename = (String) e.nextElement();
            boss.setFtpStatus("uploading "+filename+"..");
            String remoteDir = info.getRealRemoteDir(filename);
            if(remoteDir == null){
                boss.setFtpStatus("File name wrong..");
                //ftp.disconnect();
                //return;
                continue;
            }
            ftp.cd(remoteDir);
            System.out.print(ftp.lastReply());
            if (ftp.lastCode() != FTP.CODE_CD_OK)
            {
                boss.setFtpStatus("the directory does not exist.");
                //ftp.disconnect();
                //return;
                continue;
            }
            String realFileName = info.getRealFileName(filename);
            ftp.upload(filename,realFileName);
            System.out.print(ftp.lastReply());
            if (ftp.lastCode() != FTP.CODE_TRANSFER_OK)
            {
                boss.setFtpStatus("error while uploading.");
                //ftp.disconnect();
                //return;
                continue;
            }
        }
        boss.setFtpStatus("Disconnectiong...");
        ftp.disconnect();
        System.out.print(ftp.lastReply());
        if (ftp.lastCode() != FTP.CODE_DISCONNECT_OK)
        {
            boss.setFtpStatus("disconnection failed.");
            return;
        }
        ftp.closeLogFile();

        boss.setFtpStatus("OK.");        
    }

}
