/* GFWindowController */

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;
import java.util.*;

public class GFWindowController extends NSWindowController {

    NSTextFieldCell hostAddress;
    NSTextFieldCell localDir;
    NSSecureTextFieldCell password;
    //NSSecureTextFieldCell password;    
    NSTextFieldCell remoteDir;
    NSTextFieldCell userName;    
    NSWindow window;
    NSComboBox setName;

    Vector siteInfo;
    Vector temp_siteInfo;
    GFCtrl boss;
    
    public GFWindowController(){
        super("GFDiag");
    }
    public GFWindowController(String nibName)
    {
        super(nibName);    
        temp_siteInfo = new Vector();

    }
       
    public void setSiteInfo(Vector _siteInfo){
        siteInfo = _siteInfo;
    }
    
    public void setBoss(GFCtrl _boss){boss = _boss;}
    
    public void awakeFromNib(){
        updateSetMenu(); 
 //System.out.println("updatemenu called");
        if(temp_siteInfo.size() > 0){
            setName.selectItemAtIndex(0);
            setName.setObjectValue(setName.objectValueOfSelectedItem());
        }        
    }
    
    public void updateInfo(){
       temp_siteInfo.removeAllElements();
        for(int i = 0;i<siteInfo.size();i++){
        
            ConnectionInfo info = (ConnectionInfo)(siteInfo.elementAt(i));
            temp_siteInfo.addElement(info.duplicate());
        }         
        if(setName != null) updateSetMenu(); 
    }
    
    public void updateSetMenu(){ 
        setName.removeAllItems();
        for(int i = 0;i<temp_siteInfo.size();i++){
            ConnectionInfo info = (ConnectionInfo)(temp_siteInfo.elementAt(i));
            setName.addItemWithObjectValue(info.getSetName());
        }

    }
    
    //////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////
            
    public void okAction(Object sender){
    // OK pushed. save values..
        confirmAction(null);
    ///copy back all the data...
        siteInfo.removeAllElements();
        for(int i = 0;i<temp_siteInfo.size();i++){
            siteInfo.addElement(temp_siteInfo.elementAt(i));
        }
        boss.saveSettingAction();
        close();
    }
    public void closeWindow(Object sender){
    // just close the dialog.. called from cancel
        close();
    }
        
    public void deleteAction(Object sender){
    // delete button pushed. delete current setting
        String setNameString = getSetName();
        if(setNameString == null) return; 
        ConnectionInfo info = getSetNameWithName(setNameString);
        if(info != null){
            temp_siteInfo.removeElement(info);
            updateSetMenu();
        }   
        if(temp_siteInfo.size() > 0){
            setName.selectItemAtIndex(0);
            setName.setObjectValue(setName.objectValueOfSelectedItem());
        }               
    }
    
    public void confirmAction(Object sender){
    // confirm current data
        String setNameString = getSetName();
        if(setNameString == null) return;
        ConnectionInfo info = getSetNameWithName(setNameString);
        if(info == null){
            info = new ConnectionInfo();
            info.setSetName(setNameString);
            temp_siteInfo.addElement(info);
            updateSetMenu();
        }
        info.setHostAddress(hostAddress.stringValue());
        info.setUserName(userName.stringValue());
        info.setPassword(password.stringValue());
        info.setRemoteDir(remoteDir.stringValue());
        info.setLocalDir(localDir.stringValue());
    }
    
    public void comboBoxSelectionIsChanging(NSNotification notification){
        confirmAction(null);
    }
    
    public  void comboBoxSelectionDidChange(NSNotification notification){
    
        setName.setObjectValue(setName.objectValueOfSelectedItem());
//System.out.println("setname = " + setName.stringValue());
        String setNameString = getSetName();

        if(setNameString == null){
            clearEntry();
            return;
        }
        ConnectionInfo info = getSetNameWithName(setNameString);
      
        if(info == null){
            clearEntry();
        }        
        else{
//System.out.println("hostname = " + info.getHostAddress());          
            hostAddress.setStringValue(info.getHostAddress());
            userName.setStringValue(info.getUserName());
            password.setStringValue(info.getPassword());
            remoteDir.setStringValue(info.getRemoteDir());
            localDir.setStringValue(info.getLocalDir());
        }
    }
    private void clearEntry(){
            hostAddress.setStringValue("");
            userName.setStringValue("");
            password.setStringValue("");
            remoteDir.setStringValue("");
            localDir.setStringValue("");    
    }
    private String getSetName(){
	String _setName = setName.stringValue(); 
        if(_setName == null) return null;
        if(_setName.equals("")) return null;
        return _setName;   
    }
    
    private ConnectionInfo getSetNameWithName(String name){
        for(int i = 0;i<temp_siteInfo.size();i++){
            ConnectionInfo info = (ConnectionInfo)(temp_siteInfo.elementAt(i));
//System.out.println("seeking" + name + " " + (info.getHostAddress()));           
            if((info.getSetName()).equals(name)) return info;
        }
        return null;
    }
    /////////////////////////////////////////////////////////////////////////    
    //////// localDir select dialog related...
    /////////////////////////////////////////////////////////////////////////
    NSSelector selector = new NSSelector("acceptsResult",
        new Class[]{NSWindow.class, int.class, Object.class});

    // pop up file selection dialog
    public void selectDir(Object sender){
        NSOpenPanel panel = (NSOpenPanel.openPanel());
        panel.setCanChooseDirectories(true);
        panel.setCanChooseFiles(false);
        panel.setAllowsMultipleSelection(false);
        panel.setPrompt(NSBundle.mainBundle().localizedStringForKey("CFSelectFileButtonMessage","Select",null));

        panel.beginSheetForDirectory(NSSystem.currentHomeDirectory(),
                "Select Local Dir", null, window , this,selector, null);
    }
    
    // return from dialog..
    protected void acceptsResult(NSOpenPanel sheet, int returncode, Object contextinfo){
        if(sheet.filenames() == null) return;
        String filepath = (String)((sheet.filenames()).objectAtIndex(0));
        if(filepath == null) return;
        //System.out.println(filepath);
        localDir.setStringValue(filepath);
    }
}// end of class GFWindowController
